package bnrobot.classification.knn.confianca;

import java.util.ArrayList;
import java.util.Collection;
import java.util.TreeSet;

import bnrobot.core.ClassificationResult;
import bnrobot.core.Classificator;
import bnrobot.core.DocCollection;
import bnrobot.core.Similarity;
import bnrobot.core.TfIdfElement;
import bnrobot.core.models.DocumentElement;
import bnrobot.core.models.LabeledDocument;
import bnrobot.core.models.Subject;
import bnrobot.vectorSpace.VSElement;

public class ConfiancaKNN implements Classificator {

	private final double taxa = 0.01;

	private final double minMaxSim = 0.21;

	private Collection<TfIdfElement<LabeledDocument>> labeledDocuments = null;

	public ClassificationResult categoryOf(Subject subject,
			DocCollection collection) {
		this.treinaSeNecessario(collection);

		TfIdfElement<Subject> subjectIdf = new TfIdfElement<Subject>(
				collection.getIdf(), subject);

		Similarity<Subject, LabeledDocument> maxSim = vizinho(subjectIdf,
				this.labeledDocuments, this.minMaxSim);
		return new ClassificationResult(maxSim.getValue() > this.minMaxSim ? 1
				: 2, Double.valueOf(maxSim.getValue()));
	}

	private void treinaSeNecessario(DocCollection collection) {
		Collection<TfIdfElement<LabeledDocument>> documentos = this
				.getElements(collection);
		return;

		// if (this.minMaxSim != 0) {
		// return;
		// }
		//
		// int i = 0;
		//
		//
		// int maxC = documentos.size();
		//
		// TreeSet<Double> similarities = new TreeSet<Double>();
		//
		// for (TfIdfElement<LabeledDocument> doc1 : documentos) {
		// if (((i * 1000) / maxC) == 100) {
		// int p = (i * 100) / maxC;
		// System.out.println("Andamento: " + p + "%");
		// }
		// Double max = vizinho(doc1, documentos).getValue();
		// similarities.add(max);
		// }
		//
		// this.minMaxSim = this.getMinmax(similarities);
		// System.out.println("MinMax: " + this.minMaxSim);
	}

	private static <E extends VSElement> Similarity<E, LabeledDocument> vizinho(
			TfIdfElement<E> element,
			Collection<TfIdfElement<LabeledDocument>> documentos, double simMin) {
		Double max = 0D;
		Similarity<E, LabeledDocument> maxSim = null;
		for (TfIdfElement<LabeledDocument> doc2 : documentos) {
			Similarity<E, LabeledDocument> sim = new Similarity<E, LabeledDocument>(
					element, doc2);
			if (!element.getElement().equals(doc2.getElement())
					&& sim.getValue() > max) {
				max = sim.getValue();
				maxSim = sim;
			}
			if (simMin != 0 && sim.getValue() > simMin) {
				return sim;
			}
		}
		return maxSim;
	}

	private double getMinmax(TreeSet<Double> similarities) {
		int posFinal = (int) (this.taxa * similarities.size());
		int i = 0;
		for (Double sim : similarities) {
			i++;
			if (i >= posFinal) {
				return sim;
			}
		}
		return 0;
	}

	private Collection<TfIdfElement<LabeledDocument>> getElements(
			DocCollection collection) {

		this.labeledDocuments = new ArrayList<TfIdfElement<LabeledDocument>>();
		for (LabeledDocument document : collection.getLabeledDocuments()) {
			if (document.getLabel().equals(1)) {
				this.labeledDocuments.add(new TfIdfElement<LabeledDocument>(
						collection.getIdf(), document));
			}
		}
		return this.labeledDocuments;
	}

	public void learn(DocumentElement element, Integer label) {
		// this.minMaxSim = 0;
	}

	public void commit() {
		// NADA
	}

}
