package bnrobot.classification.rocchio;

import java.util.HashMap;
import java.util.Map;

import bnrobot.clustering.hierarchical.Group;
import bnrobot.core.ClassificationResult;
import bnrobot.core.Classificator;
import bnrobot.core.DocCollection;
import bnrobot.core.Similarity;
import bnrobot.core.models.DocumentElement;
import bnrobot.core.models.Subject;

public class Rocchio implements Classificator {

	private final Map<Integer, Group> grupos = new HashMap<Integer, Group>();

	public ClassificationResult categoryOf(Subject subject,
			DocCollection collection) {
		double maxSim = 0;
		Group melhor = null;
		for (Group grupo : this.grupos.values()) {
			Similarity<Subject, Group> sim = new Similarity<Subject, Group>(
					subject, grupo, collection);
			if (sim.getValue() > maxSim) {
				melhor = grupo;
				maxSim = sim.getValue();
			}
		}
		return melhor != null ? new ClassificationResult(melhor.getId(), maxSim)
				: null;
	}

	public void learn(DocumentElement element, Integer label) {
		Group group = new Group(label, element);
		if (!this.grupos.containsKey(label)) {
			this.grupos.put(label, group);
		} else {
			Group novo = new Group(label, group, this.grupos.get(label));
			this.grupos.put(label, novo);
		}
	}

	public void commit() {
		// TODO Auto-generated method stub
	}

}
