package bnrobot.configuration;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class CollectionConfiguration {

	private String analyzerName = "Portuguese";
	// private String dbPath = "/tmp/collection/Portuguese";
	private String dbPath = "/home/willian/tcc/run/Portuguese";
	private String[] stopWords = { "o", "do", "a", "da", "feir", "que", "e",
			"em", "uma", "na", "de", "foi", "no", "com", "um", "dos", "nao",
			"par", "ao", "os", "das", "se", "as", "por", "pel", "segund",
			"ser", "com" };
	private double familyFloor = 0.2;
	private double subjectFloor = 0.5;

	public String getAnalyzerName() {
		return this.analyzerName;
	}

	public String getDbPath() {
		return this.dbPath;
	}

	public Set<String> stopWords() {
		return new HashSet<String>(Arrays.asList(this.stopWords));
	}

	public double getFamilyFloor() {
		return this.familyFloor;
	}

	public double getSubjectFloor() {
		return this.subjectFloor;
	}

	public void setSubjectFloor(double subjectFloor) {
		this.subjectFloor = subjectFloor;
	}

	public void setFamilyFloor(double familyFloor) {
		this.familyFloor = familyFloor;
	}

	public void setStopWords(String[] stopWords) {
		this.stopWords = stopWords;
	}

	public String[] getStopWords() {
		return this.stopWords;
	}

	public void setDbPath(String dbPath) {
		this.dbPath = dbPath;
	}

	public void setAnalyzerName(String analyzerName) {
		this.analyzerName = analyzerName;
	}

}
