package bnrobot.core.models;

import bnrobot.core.Persistible;
import bnrobot.vectorSpace.VSElement;

public class LabeledDocument implements VSElement, Persistible {

	private static final long serialVersionUID = 1L;

	private DocumentElement element;
	private Integer label;

	public LabeledDocument(DocumentElement element, Integer label) {
		this.element = element;
		this.label = label;
	}

	public int[] getIndexes() {
		return this.element.getIndexes();
	}

	public double[] getValues() {
		return this.element.getValues();
	}

	public Integer getLabel() {
		return this.label;
	}

	public DocumentElement getElement() {
		return this.element;
	}

	public Integer getId() {
		return this.element.getId();
	}

}
