package bnrobot.core.provider;

import bnrobot.core.models.DocumentElement;

/**
 * Interface para provider de Documentos
 * 
 * @author willian
 * 
 */
public interface DocumentProvider {

	/**
	 * Salva um documento
	 * 
	 * @param document
	 *            documento
	 * @return id do documento
	 */
	int save(DocumentElement document);

	/**
	 * Procura um documento pelo id
	 * 
	 * @param id
	 *            id do documento
	 * @return documento
	 */
	DocumentElement getDocumentElement(int id);

	/**
	 * @return Quantidade de documentos
	 */
	int size();

	/**
	 * @return Todos os documentos
	 */
	Iterable<DocumentElement> documents();

	/**
	 * Procura pelos documentos de um subject
	 * 
	 * @param subject
	 *            subject
	 * @return documentos do subject
	 */
	Iterable<DocumentElement> findBySubject(Integer subject);
}
