package bnrobot.core.provider;

import bnrobot.core.models.Family;

public interface FamilyProvider {

	/**
	 * 
	 * @return todas as familias de documentos
	 */
	Iterable<Family> families();

	/**
	 * 
	 * @return Quantidade de documentos
	 */
	int size();

	/**
	 * Adiciona e salva um documento novo
	 * 
	 * @param family
	 *            familia de documento
	 * @return id
	 */
	int save(Family family);

	/**
	 * Salva as mudanças
	 */
	void commit();
}
