package bnrobot.core.provider;

import java.util.Collection;

import bnrobot.core.models.LabeledDocument;

/**
 * Provider para documentos com Label, utilizados como conjunto de treino para
 * classificação
 * 
 * @author willian
 * 
 */
public interface LabeledDocumentProvider {

	/**
	 * Salva um novo documento com label
	 * 
	 * @param doc
	 *            documento
	 * @return id do documento
	 */
	int save(LabeledDocument doc);

	/**
	 * 
	 * @return Documentos com label
	 */
	Collection<LabeledDocument> values();

	/**
	 * 
	 * @return quantidade de documentos com label
	 */
	int size();

}
