package bnrobot.core.provider;

import bnrobot.core.models.Subject;

/**
 * Interface para Providers de Subjecs
 * 
 * @author willian
 * 
 */
public interface SubjectProvider {
	/**
	 * @return uantidade de subjects
	 */
	int size();

	/**
	 * grava um novo subject e retorna o id
	 * 
	 * @param subject
	 *            subject que será gravado
	 * @return id do subject
	 */
	Integer save(Subject subject);

	/**
	 * Commita alterações
	 */
	void commit();

	/**
	 * Procura por um subject pelo id
	 * 
	 * @param id
	 *            id do subject
	 * @return subject encontrado
	 */
	Subject getSubject(int id);

	/**
	 * @return todos os subjects
	 */
	Iterable<Subject> subjects();

	/**
	 * Remove um subject
	 * 
	 * @param id
	 *            do subject que será removido
	 */
	void remove(int id);

}
