package bnrobot.jdbm.persister;

import java.io.IOException;
import java.util.Map;

import jdbm.PrimaryTreeMap;
import jdbm.RecordManager;
import jdbm.Serializer;
import jdbm.SerializerInput;
import jdbm.SerializerOutput;
import bnrobot.core.models.Family;

/**
 * 
 * @author Willian Gigliotti
 * 
 */
public class FamilyDao implements Serializer<Family> {

	PrimaryTreeMap<Integer, Family> families;

	public FamilyDao(RecordManager recman) {
		families = recman.treeMap("families");
	}

	public Family deserialize(SerializerInput in) throws IOException,
			ClassNotFoundException {
		return in.readObject();
	}

	public void serialize(SerializerOutput out, Family family)
			throws IOException {
		out.writeObject(family);
	}

	public Family familyById(Integer key) {
		return families.get(key);
	}

	public Iterable<Family> families() {
		return families.values();
	}

	public Map<Integer, Family> map() {
		return families;
	}

	public void putAll(Map<Integer, Family> map) {
		families.putAll(map);
	}

	public int size() {
		return families.size();
	}

	public int lastKey() {
		return families.lastKey();
	}

	public int nextKey() {
		return families.size() == 0 ? 1 : families.lastKey();
	}

}
