package bnrobot.jdbm.persister;

import java.util.Collection;

import jdbm.PrimaryTreeMap;
import jdbm.RecordManager;
import bnrobot.core.models.LabeledDocument;
import bnrobot.core.provider.LabeledDocumentProvider;

public class LabeledDocumentDao implements LabeledDocumentProvider {
	PrimaryTreeMap<Integer, LabeledDocument> labeledDocuments;

	public LabeledDocumentDao(RecordManager recman) {
		this.labeledDocuments = recman.treeMap("labeledDocuments");
	}

	public int save(LabeledDocument doc) {
		this.labeledDocuments.put(doc.getElement().getId(), doc);
		return doc.getElement().getId();
	}

	public Collection<LabeledDocument> values() {
		return this.labeledDocuments.values();
	}

	public int size() {
		return this.labeledDocuments.size();
	}

}
