package bnrobot.tests;

import javax.management.RuntimeErrorException;

public enum Cronometro {
	RELOADING(), LOADING(), TRAINING(), CLUSTERING(), CLASSIFICATION(), COMMIT(), CLOSE(), SAVING(), TOTAL();

	private long totalTime;
	private long startTime;

	private Cronometro() {
		this.totalTime = 0;
		this.startTime = 0;
	}

	public void start() {
		if (this.startTime != 0) {
			throw new RuntimeErrorException(null,
					"Dando start em cronometro já rodando");
		}
		this.startTime = System.currentTimeMillis();
	}

	public void stop() {
		if (this.startTime == 0) {
			throw new RuntimeErrorException(null,
					"Dando stop em cronometro já parado");
		}
		this.totalTime += System.currentTimeMillis() - this.startTime;
		this.startTime = 0;
	}

	public void stop(String debug) {
		this.stop();
		System.out.println("[" + debug + "]Cronometro " + this + " parado em "
				+ this.getTime());
	}

	public long getTime() {
		return this.totalTime;
	}

	public static void showTimes() {
		System.out.println("******** Tempos ********");
		for (Cronometro cronometro : Cronometro.values()) {
			System.out.println(cronometro.toString() + ": "
					+ cronometro.getTime());
		}
		System.out.println("************************");
	}
}
