package bnrobot.vectorSpace;

/**
 * 
 * @author willian
 *
 */
public class Operations {
	
	/**
	 * Calcula o produto escalar entre dois vetores
	 * @param elementA vetor A
	 * @param elementB vetor B
	 * @return produto escalar
	 */
	public static double dotProduct(VSElement elementA, VSElement elementB) {
		int[] indexA = elementA.getIndexes();
		int[] indexB = elementB.getIndexes();

		double[] valuesA = elementA.getValues();
		double[] valuesB = elementB.getValues();

		int pA = 0, pB = 0;
		double similarity = 0;

		while (pA < indexA.length && pB < indexB.length) {
			if (indexA[pA] == indexB[pB]) {
				similarity += valuesA[pA] * valuesB[pB];
				pA++;
				pB++;
			} else if (indexA[pA] > indexB[pB]) {
				pB++;
			} else {
				pA++;
			}
		}

		return similarity;
	}
}
