package bnrobot.vectorSpace;


/**
 * VSElement é uma sugestão simples para implementação de vetores esparsos, que
 * são muito grandes e são usados para grande quantidade de processamento e poucas alterações neles. <br />
 * 
 * Ele quebra o vetor, que seria: { 0, 0, 0, 0, 1, 5, 3, 0, 0, 3, 0, 0, 0 } <br/>
 * Em dois vetores: <br />
 * indices = { 4, 5, 6, 9 }; <br />
 * valores = { 1, 5, 3, 3 }; <br />
 * 
 * 
 * 
 * @author Willian Gigliotti
 * 
 */
public interface VSElement {
	/**
	 * 
	 * @return retorna os indices do valores diferentes de 0 para o elemento no
	 *         espaço vetorial
	 */
	int[] getIndexes();

	/**
	 * 
	 * @return os valores referentes ao indices {@link VSElement#getIndexes()}
	 */
	double[] getValues();
}
