package bnrobot.similarity;

import org.junit.Test;
import static org.junit.Assert.assertEquals;


import bnrobot.core.Similarity;
import bnrobot.core.TfIdfElement;
import bnrobot.mocks.VSMock;
import bnrobot.vectorSpace.VSElement;

public class SimilarityTest {

	@Test
	public void testZero() {
		TfIdfElement<VSElement> zero = getZero();
		Similarity<VSElement, VSElement> sim = new Similarity<VSElement, VSElement>(zero, zero);
		assertEquals("Zero x Zero, tem que dar 0", 0.0, sim.getValue(), 0.00001);
	}
	
	@Test
	public void testOrtogonais() {
		TfIdfElement<VSElement> a = getRandomAt(0, 2, 4, 6);
		TfIdfElement<VSElement> b = getRandomAt(9, 11, 14, 16);
		Similarity<VSElement, VSElement> sim = new Similarity<VSElement, VSElement>(a, b);
		assertEquals("similaridade de ortogonais tem que ser 0", 0.0, sim.getValue(), 0.00001 );
	}
	
	
	private static TfIdfElement<VSElement> getZero() {
		VSMock zero = VSMock.zero();
		assertEquals("Normal de 0 tem que ser 0", 0, zero.getLength(), 0.0001);
		return zero;
	}
	
	
	public static TfIdfElement<VSElement> getRandomAt(int... indexes) {
		VSMock mock = new VSMock();
		for(int index: indexes) {
			mock.setValue(index, Math.random() + 0.0001);
		}
		if(indexes.length > 0) {
			assertEquals("Normal dos mocks maiores de 1 tem que ser 1", 1.0, mock.getLength(), 0.0001);
		}
		return mock;
	}
}
