package br.com.w2it.filter;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import bnrobot.configuration.CollectionConfiguration;
import bnrobot.core.controller.CollectionController;
import bnrobot.core.controller.CollectionControllerFactory;

public class AppStarter {

	private final Connection con;
	private final CollectionController controller;
	private final Configuration config;

	public AppStarter() throws ClassNotFoundException, SQLException,
			IOException {
		this.config = new Configuration();
		this.con = this.getConnection();
		this.controller = new CollectionControllerFactory()
				.getController(new CollectionConfiguration());

	}

	private Connection getConnection() throws ClassNotFoundException,
			SQLException {
		Class.forName("com.mysql.jdbc.Driver");

		String url = this.config.getUrl();

		Connection con = DriverManager.getConnection(url,
				this.config.getUsername(), this.config.getPassword());
		return con;
	}

	public CollectionController getController() {
		return this.controller;
	}

}
