package br.com.w2it.filter;

public class RobotQueries {

	/**
	 * Query que pega os elementos da fila para serem processados
	 * 
	 * @param step
	 * @return query
	 */
	public String findDocumentQueue(int step) {
		return "select * from Queue order by bn_id limit " + step;
	}

	public String findTrainingQueue(int step) {
		return "select * from TrainingQueue order by bn_id limit " + step;
	}

	/**
	 * Query que procura um subject pelo seu ID
	 * 
	 * @param subjectId
	 *            id do subject
	 * @return query
	 */
	public String findSubjectById(Integer subjectId) {
		return "select * from Subject where bn_id = " + subjectId;
	}

	/**
	 * Query que atualiza o subject a partir de um novo documento
	 * 
	 * @param lastDocumentId
	 *            id do novo documento
	 * @param subjectId
	 *            id do subject
	 * @return query
	 */
	public String updateSubject(Integer lastDocumentId, Integer subjectId,
			String data) {
		return "update Subject set bn_last_document = "
				+ lastDocumentId
				+ " , bn_last_date = '"
				+ data
				+ "' "
				+ " , bn_last_update = now(), bn_updated = true, bn_size = bn_size + 1 where bn_id = "
				+ subjectId;
	}

	/**
	 * Query que insere uma linha na tabela de subject
	 * 
	 * @param subjectId
	 * @param elementId
	 * @param label
	 * @return
	 */
	public String insertSubject(Integer subjectId, Integer elementId,
			Integer label, Double score, String data) {
		if (label != null) {
			return "insert into Subject (bn_id, bn_last_document, bn_last_date, bn_label, bn_score, bn_updated) values ( "
					+ subjectId
					+ ", "
					+ elementId
					+ ", "
					+ "'"
					+ data
					+ "'"
					+ ", " + label + ", " + score + " , true );";
		} else {
			return "insert into Subject (bn_id, bn_last_document, bn_last_date, bn_updated) values ( "
					+ subjectId
					+ ", "
					+ elementId
					+ ", '"
					+ data
					+ "', true );";
		}
	}

	public String updateSubjectFromQueue(Integer elementId, Integer subjectId) {
		return "update Queue set bn_subject = " + subjectId + " where bn_id = "
				+ elementId;
	}

	public String insertArchiveFromQueue(Integer elementId) {
		return "insert into Archive ( select * from Queue where bn_id = "
				+ elementId + ");";
	}

	public String deleteFromQueue(Integer elementId) {
		return "delete from Queue where bn_id = " + elementId;
	}

	public String insertTrainingfromQueue(Integer elementId) {
		return "insert into TrainingSet ( select * from TrainingQueue where bn_id <= "
				+ elementId + ");";
	}

	public String deleteFromTraningQueue(Integer elementId) {
		return "delete from TrainingQueue where bn_id <=" + elementId;
	}

	public String findDocumentById(Integer elementId) {
		return "select out_data as data_doc from Queue where bn_id = "
				+ elementId;
	}

	public String updateSize() {
		return "update Subject sub, (select count(*) as qtd, bn_subject from Archive  arch group by arch.bn_subject) tot set sub.bn_size = tot.qtd where sub.bn_updated = 1 and sub.bn_id = tot.bn_subject";
	}
}
