package br.com.w2it.filter;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import bnrobot.configuration.CollectionConfiguration;
import bnrobot.core.DocCollection;
import bnrobot.core.Similarity;
import bnrobot.core.controller.CollectionController;
import bnrobot.core.controller.CollectionControllerFactory;
import bnrobot.core.models.DocumentElement;
import bnrobot.tests.Cronometro;

public class TestClusterXCluster {

	private final Connection con;
	private final CollectionController controller;
	private final Configuration config;

	public TestClusterXCluster() throws ClassNotFoundException, SQLException,
			IOException {
		this.config = new Configuration();
		this.con = this.getConnection();
		this.controller = new CollectionControllerFactory()
				.getController(new CollectionConfiguration());

	}

	private Connection getConnection() throws ClassNotFoundException,
			SQLException {
		Class.forName("com.mysql.jdbc.Driver");

		String url = this.config.getUrl();

		Connection con = DriverManager.getConnection(url,
				this.config.getUsername(), this.config.getPassword());
		return con;
	}

	public static void main(String[] args) throws ClassNotFoundException,
			SQLException, IOException {

		Cronometro.TOTAL.start();
		TestClusterXCluster sim = new TestClusterXCluster();

		// clustering.train();
		sim.compute();

		// TODO descomentar a linha de baixo quando ficar pronto
		// Ela que é responsável para apagar as notícias velhas...
		// clustering.deleteOld();

		Cronometro.CLOSE.start();
		Cronometro.CLOSE.stop();

		Cronometro.TOTAL.stop();
		Cronometro.showTimes();
	}

	private void compute() {
		int tamanho = 10;
		int[] distr = new int[tamanho];

		DocCollection collection = this.controller.getCollection();

		Iterable<DocumentElement> docs = collection.getDocumentProvider()
				.findBySubject(2311);

		for (DocumentElement doc1 : docs) {
			for (DocumentElement doc2 : docs) {
				if (!doc1.getId().equals(doc2.getId())) {
					Similarity<DocumentElement, DocumentElement> sim = new Similarity<DocumentElement, DocumentElement>(
							doc1, doc2, collection);
					distr[this.getDistriPosition(tamanho, sim.getValue())]++;
				}
			}
			System.out.println("indo");
		}

		for (int i = 0; i < tamanho; i++) {
			System.out.println(i + " :" + distr[i] / 2);
		}

	}

	private int getDistriPosition(int tamanho, double value) {
		double intervalo = 1.0 / tamanho;
		int val = (int) (value / intervalo);
		return val > (tamanho - 1) ? (tamanho - 1) : val;

	}

}
